/*!
 * `deployr` JavaScript Client Library v8.0.5
 * http://go.microsoft.com/fwlink/?LinkID=698842
 *
 * Copyright (C) 2010-2016, Microsoft Corporation
 * Released under the Apache License 2.0
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Includes:
 *   - superagent: https://github.com/visionmedia/superagent
 *   - ws: https://github.com/einaros/ws
 *   - D.js: http://malko.github.io/D.js
 *   - yui-lang.js: https://github.com/yui/yui3 (DeployR port)
 *
 * superagent
 *
 * Copyright (c) 2014-2015 TJ Holowaychuk <tj@vision-media.ca>
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the,
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * ws
 *
 * Copyright (c) 2011 Einar Otto Stangvik <einaros@gmail.com>
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining 
 * a copy of this software and associated documentation files 
 * (the "Software"), to deal in the Software without restriction, 
 * including without limitation the rights to use, copy, modify, merge
 * publish, distribute, sublicense, and/or sell copies of the Software, 
 * and to permit persons to whom the Software is furnished to do so, 
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be 
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, 
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF 
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY 
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, 
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE 
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * D
 *
 * Copyright (C) 2013 Jonathan Gotti <jgotti at jgotti dot net>
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the,
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * selfish
 *
 * Copyright 2011 Irakli Gozalishvili. All rights reserved
 * Open Source Initiative OSI - The MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the,
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
 * OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
 * WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * yui-lang
 *
 * The lang component is a DeployR port of yui-lang.js by Yahoo!
 *
 * Software License Agreement (BSD License)
 * Copyright (c) 2013, Yahoo! Inc. All rights reserved.
 *
 * Redistribution and use of this software in source and binary forms, 
 * with or without modification, are permitted provided that the 
 * following conditions are met:
 *
 * Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimer. Redistributions
 * in binary form must reproduce the above copyright notice, this list of
 * conditions and  the following disclaimer in the documentation and/or 
 * other materials provided with the distribution.
 * 
 * Neither the name of Yahoo! Inc. nor the names of YUI's contributors 
 * may be used to endorse or promote products derived from this software 
 * without specific prior written permission of Yahoo! Inc.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT, 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * Date: 2016-06-29
 */
!function(t){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=t();else if("function"==typeof define&&define.amd)define([],t);else{var e;e="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,e.deployr=t()}}(function(){var t;return function e(t,r,n){function i(s,a){if(!r[s]){if(!t[s]){var u="function"==typeof require&&require;if(!a&&u)return u(s,!0);if(o)return o(s,!0);var c=new Error("Cannot find module '"+s+"'");throw c.code="MODULE_NOT_FOUND",c}var h=r[s]={exports:{}};t[s][0].call(h.exports,function(e){var r=t[s][1][e];return i(r?r:e)},h,h.exports,e,t,r,n)}return r[s].exports}for(var o="function"==typeof require&&require,s=0;s<n.length;s++)i(n[s]);return i}({1:[function(t,e,r){e.exports={"/r/user/login":{method:"POST",format:"json"},"/r/user/logout":{method:"POST",format:"json"},"/r/user/about":{method:"POST",format:"json"},"/r/user/autosave":{method:"POST",format:"json"},"/r/user/release":{method:"POST",format:"json"},"/r/project/create":{method:"POST",format:"json"},"/r/project/pool":{method:"POST",format:"json"},"/r/project/recycle":{method:"POST",format:"json"},"/r/project/list":{method:"POST",format:"json"},"/r/project/ping":{method:"POST",format:"json"},"/r/project/about":{method:"POST",format:"json"},"/r/project/about/update":{method:"POST",format:"json"},"/r/project/save":{method:"POST",format:"json"},"/r/project/saveas":{method:"POST",format:"json"},"/r/project/close":{method:"POST",format:"json"},"/r/project/grant":{method:"POST",format:"json"},"/r/project/import":{method:"POST",format:"json",upload:!0},"/r/project/export":{method:"POST",format:"json"},"/r/project/delete":{method:"POST",format:"json"},"/r/project/execute/code":{method:"POST",format:"json"},"/r/project/execute/script":{method:"POST",format:"json"},"/r/project/execute/interrupt":{method:"POST",format:"json"},"/r/project/execute/console":{method:"POST",format:"json"},"/r/project/execute/history":{method:"POST",format:"json"},"/r/project/execute/flush":{method:"POST",format:"json"},"/r/project/execute/result/list":{method:"POST",format:"json"},"/r/project/execute/result/download":{method:"POST",format:"json"},"/r/project/execute/result/delete":{method:"POST",format:"json"},"/r/project/workspace/list":{method:"POST",format:"json"},"/r/project/workspace/get":{method:"POST",format:"json"},"/r/project/workspace/upload":{method:"POST",format:"json",upload:!0},"/r/project/workspace/transfer":{method:"POST",format:"json"},"/r/project/workspace/push":{method:"POST",format:"json"},"/r/project/workspace/save":{method:"POST",format:"json"},"/r/project/workspace/store":{method:"POST",format:"json"},"/r/project/workspace/load":{method:"POST",format:"json"},"/r/project/workspace/delete":{method:"POST",format:"json"},"/r/project/directory/list":{method:"POST",format:"json"},"/r/project/directory/upload":{method:"POST",format:"json",upload:!0},"/r/project/directory/transfer":{method:"POST",format:"json"},"/r/project/directory/write":{method:"POST",format:"json"},"/r/project/directory/update":{method:"POST",format:"json"},"/r/project/directory/store":{method:"POST",format:"json"},"/r/project/directory/load":{method:"POST",format:"json"},"/r/project/directory/download":{method:"POST",format:"json"},"/r/project/directory/delete":{method:"POST",format:"json"},"/r/project/package/list":{method:"POST",format:"json"},"/r/project/package/attach":{method:"POST",format:"json"},"/r/project/package/detach":{method:"POST",format:"json"},"/r/job/list":{method:"POST",format:"json"},"/r/job/submit":{method:"POST",format:"json"},"/r/job/schedule":{method:"POST",format:"json"},"/r/job/query":{method:"POST",format:"json"},"/r/job/cancel":{method:"POST",format:"json"},"/r/job/delete":{method:"POST",format:"json"},"/r/repository/directory/list":{method:"POST",format:"json"},"/r/repository/directory/create":{method:"POST",format:"json"},"/r/repository/directory/rename":{method:"POST",format:"json"},"/r/repository/directory/copy":{method:"POST",format:"json"},"/r/repository/directory/move":{method:"POST",format:"json"},"/r/repository/directory/update":{method:"POST",format:"json"},"/r/repository/script/list":{method:"POST",format:"json"},"/r/repository/script/execute":{method:"POST",format:"json"},"/r/repository/script/render":{method:"GET",format:"json"},"/r/repository/script/interrupt":{method:"POST",format:"json"},"/r/repository/directory/archive":{method:"POST",format:"json"},"/r/repository/directory/upload":{method:"POST",format:"json",upload:!0},"/r/repository/directory/download":{method:"POST",format:"json"},"/r/repository/directory/delete":{method:"POST",format:"json"},"/r/repository/file/list":{method:"POST",format:"json"},"/r/repository/file/fetch":{method:"POST",format:"json"},"/r/repository/file/fetch":{method:"POST",format:"json"},"/r/repository/file/upload":{method:"POST",format:"json",upload:!0},"/r/repository/file/transfer":{method:"POST",format:"json"},"/r/repository/file/write":{method:"POST",format:"json"},"/r/repository/file/update":{method:"POST",format:"json"},"/r/repository/file/diff":{method:"POST",format:"json"},"/r/repository/file/revert":{method:"POST",format:"json"},"/r/repository/file/grant":{method:"POST",format:"json"},"/r/repository/file/download":{method:"POST",format:"json"},"/r/repository/file/delete":{method:"POST",format:"json"},"/r/repository/file/copy":{method:"POST",format:"json"},"/r/repository/file/move":{method:"POST",format:"json"},"/r/server/info":{method:"GET",format:"json"}}},{}],2:[function(t,e,r){(function(r){function n(t,e){var r=e.deployr?e.deployr.response.errorCode:e.status,n=this;E.events&&(e.deployr||(e=e.text),n=E.events.ctx||n,E.events.error&&E.events.error.apply(n,[t,e]),E.events[r]&&E.events[r].apply(n,[t,e]))}var i="undefined"!=typeof window,o=t("superagent"),s=t("d.js"),a=t("fs"),u=t("./apis.json"),c=t("./lib/es"),h=t("./lib/utils"),l=t("./lib/lang"),p=t("./lib/logger"),f=t("./lib/queue"),d=t("./lib/emitter"),y=t("./lib/encoder"),m=t("./lib/selfish").Base,R=t("./lib/rinput"),v=t("./lib/rinputs"),T=h.merge;p.setLevel(p.OFF);var E={cors:!1,logging:!1,sticky:!1,headers:null,host:"",allowSelfSignedSSLCert:!1,maxRequests:null,events:{},set:function(t,e){"set"!==t&&("host"===t&&e&&(e=e.replace(/\/*$|\/*deployr\/*$/,""),e=new RegExp("^(http|https)://","i").test(e)?e:"http://"+e),this[t]=e)}},O=["user","project","workspace","execution","directory","repository","packages"],g="x-xsrf-token",j=m.extend(d,v,{initialize:function(t,e){d.initialize.call(this,{});var n=E;if(!u[t])throw new Error('Invalid API "'+t+'"');this.api=T({call:t},u[t]),this.link=e||{},this.q=this.link.queue||new f,this.deferred=this.link.deferred||s(),this.headers=this.link.headers,this.logger=p.get(t,p.OFF),this.params={},this.inputs=[],this.outputs=[],this.rstream=!1,this.delayed=!1,this.globalEvts=!0,this.file=null,this.entities=null,this.ioFilter=function(){return!0},this.data({format:this.api.format}),this.req=o[this.api.method.toLowerCase()](n.host+"/deployr"+t),this.req.timeout(12e5),i&&E.cors&&this.req.withCredentials(),!i&&E.allowSelfSignedSSLCert&&(r.env.NODE_TLS_REJECT_UNAUTHORIZED="0")},ctx:function(t){return this.scope=t||this,this},global:function(t){return this.globalEvts=l.isBoolean(t)?t:this.globalEvts,this},about:function(){var t=this.req.res;return"/r/user/login"===this.api.call&&t?t.body.get("user"):null},share:function(t){return E.sticky?E.headers?this.headers=E.headers:t&&(this.headers={Cookie:t["set-cookie"]||t.Cookie,"x-xsrf-token":t[g]},E.set("headers",this.headers)):this.headers=t?{Cookie:t["set-cookie"]||t.Cookie,"x-xsrf-token":t[g]}:this.headers,this},getHeaders:function(){return this.headers},getCookies:function(){return this.getHeaders()},delay:function(t){return this.delayed=!(!isNaN(parseFloat(t))&&isFinite(t))||t,this},drain:function(){return this.delayed=!1,this.q.flush(),this.deferred.promise},promise:function(){return this.end(),this.deferred.promise},abort:function(){return this.req.abort(),this.emit("abort"),this.deferred.reject(this._handleError({status:"abort",text:"DeployR request aborted."})),this},timeout:function(t){return this.req.timeout(t),this},log:function(t){return this.logger.setLevel(t||p.DEBUG),this},entity:function(t){return this.entities=h.inArray(O,t),this},data:function(t){t=t||{},(t.rinput||t.rinputs)&&(this.rinput(t.rinput),this.rinputs(t.rinputs));var e=["rinput","rinputs","__headers__"];return e.forEach(function(e){delete t[e]}),this.params=T(this.params,t),this},attach:function(t,e){return this.api.upload&&(this.file=t,e&&this.data({filename:e})),this},stream:function(){return this.rstream=!i&&this.api.upload,this},filter:function(t){return t&&(this.ioFilter=function(e){var r,n={};for(var i in e)"__headers__"!==i&&(n[i]=e[i]);return r=t(n),!r&&r!==!1||r}),this},ensure:function(t){return this.deferred.promise.ensure(t),this.deferred.promise},error:function(t){return this.on("error",t),this},pipe:function(t){var e=this.q,r=this.api;return e.add(function(n,i,o){if(i)return this.deferred.reject(i),e.flush(n,i,o),void this._clear();this._prepRequest(n,o),p.info("pipe()",r,this.req),this.logger.info("pipe()",r,this.req);var s=this.req.pipe(t);e["yield"](!0),s.on("error",function(){}),s.on("end",function(){}),s.on("data",function(){})},this),e.size()<=1&&e.flush(),t},end:function(t){var e=this,r=this.q,n=this.api,o=null,s=this.entities;return r.add(function(a,u,c){return u?(this.deferred.reject(u),r.flush(a,u,c),void this._clear()):this.ioFilter(c)?(this._prepRequest(a,c),p.info("io()",n,this.rexq),this.logger.info("io()",n,this.req),this.req.end(function(c){if(i&&!c.headers["set-cookie"]){var l=c.body&&c.body.deployr?c.body:c;if(l&&l.deployr){var f={};f[g]=l.deployr.response["X-XSRF-TOKEN"],f[g]&&e.share(f)}}e.share(e.headers||c.headers),e.headers&&(p.info("Cookie",n,e.headers.Cookie),e.logger.info("Cookie",n,e.headers.Cookie),p.info(g,n,e.headers[g]),e.logger.info(g,n,e.headers[g])),u=e._handleError(c);var d=c.body&&c.body.deployr?c.body:c;e.inputs=[],e.outputs=[],u||(p.info("end()",n,d,c),e.logger.info("end()",n,d,c),s&&(d=d.deployr.response[s]||d),d.get=function(t){return h.get(d.deployr.response,t)},d.workspace=function(t){return h.workspace(d.deployr.response,t)},t&&(o=t.apply(e.scope,[d,a])),0===r.size()&&(e._clear(),e.deferred.resolve(a||d)),o=T(o,{__headers__:e.headers})),r["yield"](!1),r.flush(d,u,o)}),void r["yield"](!0)):(0===r.size()&&this.deferred.resolve(a||c),r.flush(a,u,c),void this._clear())},this,this.delayed),!this.delayed&&r.size()<=1&&r.flush(),this},io:function(t){return j["new"](t,{headers:this.getHeaders(),queue:this.q,deferred:this.deferred})},script:function(){var t=h.signature(arguments),e=t.opts,r=t.api,n={headers:this.getHeaders(),queue:this.q,deferred:this.deferred};return t.create?j["new"]("/r/project/create",n).end(function(t){return{project:t.get("project").project}}).io(r).data(e):j["new"](r,n).data(e)},code:function(t,e){var r={headers:this.getHeaders(),queue:this.q,deferred:this.deferred},n="/r/project/execute/code";return e?j["new"](n,r).data({code:t,project:e}):j["new"]("/r/project/create",r).end(function(t){return{project:t.get("project").project}}).io(n).data({code:t})},release:function(t,e){function r(t){t===u&&(e?(i.resolve(!0),n.destroy()):j["new"]("/r/user/logout").share(c).error(function(){i.reject(!1)}).end(function(){i.resolve(!0)}).ensure(function(){n.destroy()}))}t=l.isArray(t)?t:[t];var n=this,i=s(),o=!t||!t[0],a=0,u=o?a:t.length-1,c=this.getHeaders();return o?r(a):t.forEach(function(t){j["new"]("/r/project/close").data({project:t}).share(c).end().ensure(function(){r(a),a++})}),i.promise},routputs:function(t){return t&&(this.outputs=this.outputs.concat(t)),this},routput:function(t){return t&&this.routputs([t]),this},rinputs:function(t){return t&&(this.inputs=this.inputs.concat(t)),this},rinput:function(t){return t&&this.inputs.push(t),this},destroy:function(){try{this.emit("destroy"),this.offAll();for(var t in this)this.hasOwnProperty(t)&&(this[t]=null,delete this[t])}catch(e){}},_clear:function(){this.params={},this.inputs=[],this.outputs=[],this.rstream=!1,this.delayed=!1,this.api=null,this.file=null,this.entities=null,this.ioFilter=null},_prepRequest:function(t,e){var r=this.req,n=this.file;if(this.api.upload?i||this.req.type("multipart/form-data"):r.type("form"),r.on("error",function(t){t=t||{code:"UNKNOWN CODE",text:"UNKNOWN ERROR"},this._handleError({status:t.code||"UNKNOWN CODE",text:t})}.bind(this)),this.share(e?e.__headers__:null),e&&this.data(e),this.inputs.length>0&&this.data({inputs:y.encode(this.inputs)}),this.outputs.length>0&&this.data({robjects:this.outputs.join()}),this.headers)for(var o in this.headers)this.headers.hasOwnProperty(o)&&this.headers[o]&&r.set(o,this.headers[o]||"");if(this.api.upload){for(var s in this.params)r.field(s,this.params[s]||this.params[s]===!1?this.params[s]+"":"");r.attach("file",this.rstream?a.createReadStream(n):n)}else r["GET"===this.api.method?"query":"send"](this.params)},_handleError:function(t){var e=t.status,r=t.body&&t.body.deployr?t.body:t,i=200!==e||r.deployr&&!r.deployr.response.success;return i&&(r={get:function(t){return h.get(this.deployr.response,t)},deployr:{response:{success:!1,call:this.api.call,errorCode:r.deployr?r.deployr.response.errorCode:e,error:r.deployr?r.deployr.response.error:r.text}}},p.error("error()",this.api,r,t),this.logger.error("error()",this.api,r,t),this.globalEvts&&n(this.api.call,r),this.emit("error",r),this.emit("deployr-io:"+r.deployr.response.errorCode,r),this.deferred.reject(r)),i}});e.exports={DeployR:j,apis:function(t){return t?Object.keys(u):u},configure:function(t){t=t||{};for(var e in t)E.set(e,t[e]);return E.sticky||E.set("headers",null),p.setLevel(E.logging?p.DEBUG:p.OFF),this},io:function(t){return j["new"](t)},auth:function(t,e){var r={username:t,password:e};return j["new"]("/r/user/login").data(r).end()},script:function(){var t=h.signature(arguments),e=t.opts,r=t.api;return t.create?j["new"]("/r/project/create").end(function(t){return{project:t.get("project").project}}).io(r).data(e):j["new"](r).data(e)},pipeline:function(t){function e(){i.add(function(){t.shift().drain().then(function(t){o.push(t),a.push(u),i.isEmpty()&&(r.configure(c),n.resolve({results:o,errors:a})),i.take()},function(t){o.push(u),a.push(t),i.isEmpty()&&0===o.length&&(r.configure(c),n.reject(a)),i.take()})},null,!0)}var r=this,n=s(),i=new f,o=[],a=[],u=null,c={sticky:E.sticky,headers:E.headers};t=t.slice(0),r.configure({sticky:!0});for(var h=0;h<t.length;h++)e();return i.take(),n.promise},es:function(t){var e=t&&t.username&&t.password,r=c["new"](E.host,{"yield":e});if(e){var n=this.auth(t.username,t.password);n.ensure(function(){r.share(n.getHeaders()),r.flush()})}return r},RInput:{numeric:function(t,e){return R["new"](t,e).numeric()},integer:function(t,e){return R["new"](t,e).integer()},logical:function(t,e){return R["new"](t,e).logical()},character:function(t,e){return R["new"](t,e).character()},date:function(t,e){return R["new"](t,e).date()},posixct:function(t,e){return R["new"](t,e).posixct()},numericVector:function(t,e){return R["new"](t,e).numericVector()},integerVector:function(t,e){return R["new"](t,e).integerVector()},logicalVector:function(t,e){return R["new"](t,e).logicalVector()},characterVector:function(t,e){return R["new"](t,e).characterVector()},dateVector:function(t,e){return R["new"](t,e).dateVector()},posixctVector:function(t,e){return R["new"](t,e).posixctVector()},list:function(t,e){return R["new"](t,e).list()},dataframe:function(t,e){return R["new"](t,e).dataframe()},factor:function(t,e,r,n){var i={levels:r,labels:n};return R["new"](t,e,i).factor()},ordered:function(t,e,r,n){var i={levels:r,labels:n};return R["new"](t,e,i).ordered()},numericMatrix:function(t,e){return R["new"](t,e).numericMatrix()},integerMatrix:function(t,e){return R["new"](t,e).integerMatrix()},logicalMatrix:function(t,e){return R["new"](t,e).logicalMatrix()},characterMatrix:function(t,e){return R["new"](t,e).characterMatrix()}}}}).call(this,t("_process"))},{"./apis.json":1,"./lib/emitter":3,"./lib/encoder":4,"./lib/es":5,"./lib/lang":6,"./lib/logger":7,"./lib/queue":9,"./lib/rinput":10,"./lib/rinputs":11,"./lib/selfish":13,"./lib/utils":14,_process:16,"d.js":17,fs:15,superagent:18}],3:[function(t,e,r){function n(t){}var i=t("./selfish").Base;e.exports=i.extend({initialize:function(){this.events={},this.scope=null},on:function(t,e){return t in this.events==!1&&(this.events[t]=[]),this.events[t].push(e),n('Emitter.on("'+t+'")'),this},emit:function(t){if(t in this.events==!1)return this;for(var e=0;e<this.events[t].length;e++)n('Fired event: "'+t+'"'),this.events[t][e].apply(this.scope||this,Array.prototype.slice.call(arguments,1));return this},offAll:function(t){if(t){if(t in this.events==!1)return this;delete this.events[t]}else for(var e in this.events)delete this.events[e];return this},offAt:function(t,e){var r=this.events[t],n=r.slice(e+1);r.length=e,r.push.apply(r,n),this.events[t]=r},off:function(t,e){if(t in this.events==!1)return this;if(!e)return this.offAll(t);for(var r=0;r<this.events[t].length;r++)if(this.events[t][r]==e)return this.offAt(t,r),this;return this}})},{"./selfish":13}],4:[function(t,e,r){function n(t,e){for(var r=[],n=0;n<t.length;n++)r.push(i(t[n],e));return r}function i(t,e){function r(t,e,r){for(var n=""+Math.abs(t),i=t>=0;n.length<e;)n="0"+n;return(i?r?"+":"":"-")+n}var n=t.getFullYear(),i=t.getMonth()+1,o=t.getDate(),s=t.getHours(),a=t.getMinutes(),u=t.getSeconds(),c=t.getTimezoneOffset(),h="";if(i=i<10?"0"+i:i,s=s<10?"0"+s:s,a=a<10?"0"+a:a,u=u<10?"0"+u:u,h=n+"-"+i+"-"+o,e===l.RPOSIX_DATE||e===l.RPOSIX_DATE_VECTOR){var p=s+":"+a+":"+u,f=-c,d="+";f<0&&(f=-f,d="-"),c=d+r(f/60,2)+""+r(f%60,2),h+=" "+p+" "+c}return h}function o(t,e){for(var r=t.value,s=0;s<r.length;s++){var a=r[s];a.type===l.RDATAFRAME?e=o(a,e):(c.isDate(a.type)&&(u.isArray(a.value)?a.value=n(a.value,a.type):a.value=i(a.value,a.type)),a.type=c.deployrToR(a.type),e.value.push(a))}return e}function s(t){for(var e={type:h.DATAFRAME,value:[],name:t.name},r=t.value,s=0;s<r.length;s++){var a=r[s];a.type===l.RDATAFRAME?e=o(a,e):(c.isDate(a.type)&&(u.isArray(a.value)?a.value=n(a.value,a.type):a.value=i(a.value,a.type)),a.type=c.deployrToR(a.type),e.value.push(a))}return e}function a(t){for(var e,r={type:h.LIST,value:[],name:t.name},o=t.value,u=0;u<o.length;u++){var c=o[u];switch(c.type){case l.RDATAFRAME:e=s(c);break;case l.RLIST:e=a(c);break;case l.RNUMERIC_MATRIX:case l.RINTEGER_MATRIX:case l.RBOOLEAN_MATRIX:case l.RSTRING_MATRIX:e={name:c.name,type:h.MATRIX,value:c.value};break;case l.RDATE:case l.RPOSIX_DATE:e={name:c.name,type:h.DATE,format:c.format,value:i(c.value,c.type)};break;case l.RFACTOR:case l.RORDERED:e={name:c.name,type:h.FACTOR,ordered:c.ordered,labels:c.labels,levels:c.levels,value:c.value};break;case l.RSTRING:case l.RBOOLEAN:case l.RNUMERIC:case l.RINTEGER:e={name:c.name,type:h.PRIMITIVE,value:c.value};break;case l.RNUMERIC_VECTOR:case l.RINTEGER_VECTOR:case l.RBOOLEAN_VECTOR:case l.RSTRING_VECTOR:e={name:c.name,type:h.VECTOR,value:c.value};break;case l.RDATE_VECTOR:case l.RPOSIX_DATE_VECTOR:e={name:c.name,type:h.VECTOR,value:n(c.value,c.type),format:c.format};break;default:throw new Error('No RDataType found for "'+c.type+'"')}r.value.push(e)}return r}var u=t("./lang"),c=t("./rtypes"),h=c.r,l=c.deployr;e.exports={encode:function(t){for(var e={},r=0;r<t.length;r++){var o=t[r];switch(o.type){case l.RDATAFRAME:e[o.name]=s(o);break;case l.RLIST:e[o.name]=a(o);break;case l.RNUMERIC_MATRIX:case l.RINTEGER_MATRIX:case l.RBOOLEAN_MATRIX:case l.RSTRING_MATRIX:e[o.name]={type:h.MATRIX,value:o.value};break;case l.RDATE:case l.RPOSIX_DATE:e[o.name]={type:h.DATE,format:o.format,value:i(o.value,o.type)};break;case l.RFACTOR:case l.RORDERED:e[o.name]={type:h.FACTOR,ordered:o.ordered,labels:o.labels,levels:o.levels,value:o.value};break;case l.RSTRING:case l.RBOOLEAN:case l.RNUMERIC:case l.RINTEGER:e[o.name]={type:h.PRIMITIVE,value:o.value};break;case l.RNUMERIC_VECTOR:case l.RINTEGER_VECTOR:case l.RBOOLEAN_VECTOR:case l.RSTRING_VECTOR:e[o.name]={type:h.VECTOR,value:o.value};break;case l.RDATE_VECTOR:case l.RPOSIX_DATE_VECTOR:e[o.name]={type:h.VECTOR,value:n(o.value,o.type),format:o.format};break;default:throw new Error('No RDataType found for "'+o.type+'"')}}return JSON.stringify(e)}}},{"./lang":6,"./rtypes":12}],5:[function(t,e,r){var n="undefined"!=typeof window,i=t("./optional"),o=n?window.WebSocket:i("ws"),s=t("./queue"),a=t("./emitter"),u=t("./selfish").Base,c=t("./utils").merge;e.exports=u.extend(a,{initialize:function(t,e){a.initialize.call(this,{}),this.api=(t||"")+"/deployr/r/event/stream",this.options=e||{},this.ws=null,this.q=new s,this.filter={},this.cookies=this.options.cookies},open:function(t){var e,r=this;return t=this.options=c(t||{},this.options),this.cookies=this.cookies?this.cookies:t.cookies,t.project&&this.project(t.project),t.job&&this.job(t.job),t.managementEventOnly&&this.managementEventOnly(),t.revoEventOnly&&this.revoEventOnly(),t.httpEventOnly&&this.httpEventOnly(),e=this.getRequestURL(),this.q["yield"](!0),this.q.add(function(){var t=this.cookies?{Cookie:this.cookies}:{};this.emit("es:connecting",{url:e,headers:t});var i=n?new o(e):new o(e,"http",{headers:t});i.onopen=function(t){r.emit("es:open",t)};var s="";i.onmessage=function(t){try{if(t.data.split("!|!")[1]){s+=t.data.split("!|!")[1],t=JSON.parse(s),s="";var e=t.deployr.response.event.type;r.emit("es:"+e.replace("Event",""),t)}}catch(n){}},i.onerror=function(t){r.emit("es:error",t)},i.onclose=function(t){r.emit("es:close",t)},this.ws=i},this),t["yield"]||this.flush(),this},close:function(){return this.ws&&this.ws.close(),this},getRequestURL:function(){var t=this.api.replace(/^http/,"ws"),e=this.filter;return t+=e.type?"?"+e.type:"",e.project&&(t+="&"+e.project),e.job&&(t+="&"+e.job),t},getCookies:function(){return this.cookies},destroy:function(){this.emit("destroy"),this.close(),this.offAll(),this.ws=null,this.host=null,this.options=null,this.ws=null,this.q=null,this.filter=null},flush:function(){this.q["yield"](!1),this.q.flush()},share:function(t){return this.cookies=t,this},project:function(t){return this.filter.project="project="+t,this.filter.job=null,this},job:function(t){return this.filter.job="job="+t,this.filter.project=null,this},managementEventOnly:function(){return this.filter={type:"managementEventOnly=true",project:null,job:null},this},httpEventOnly:function(){return this.filter.type="httpEventOnly=true",this},revoEventOnly:function(){return this.filter.type="revoEventOnly=true",this},all:function(){return this.filter={type:null,project:null,job:null},this},session:function(){return this.httpEventOnly()},management:function(){return this.managementEventOnly()}})},{"./emitter":3,"./optional":8,"./queue":9,"./selfish":13,"./utils":14}],6:[function(t,e,r){var n={},i=Object.prototype.toString,o={undefined:"undefined",number:"number","boolean":"boolean",string:"string","[object Function]":"function","[object RegExp]":"regexp","[object Array]":"array","[object Date]":"date","[object Error]":"error"},s=!1;n.isNull=function(t){return null===t},n.isUndefined=function(t){return"undefined"==typeof t},n.isObject=function(t,e){var r=typeof t;return t&&("object"===r||!e&&("function"===r||n.isFunction(t)))||!1},n.isArray=!s&&Array.isArray||function(t){return"array"===n.type(t)},n.isFunction=function(t){return"function"==typeof t},n.isBoolean=function(t){return"boolean"==typeof t},n.isDate=function(t){return"date"===n.type(t)&&"Invalid Date"!==t.toString()&&!isNaN(t)},n.isNumber=function(t){return"number"==typeof t&&isFinite(t)},n.isString=function(t){return"string"==typeof t},n.type=function(t){return o[typeof t]||o[i.call(t)]||(t?"object":"null")},e.exports=n},{}],7:[function(t,e,r){function n(t,e){function r(t){var e="==================================================================================================================\n",r=0;return r=t===s.DEBUG||t===s.ERROR?8:t===s.INFO||t===s.WARN?8:7,{start:e.substring(r),end:e}}if(console){var n,i=Array.prototype.slice.call(t,0),o=e.name,a=e.level===s.ERROR,u=r(e.level);n=e.level===s.WARN&&console.warn?"warn":e.level===s.ERROR&&console.error?"error":e.level===s.INFO&&console.info?"info":"log",i.unshift("["+(a?s.ERROR.name:o)+"] "+u.start),i.push(u.end),console[n](i[0],[i[1]+" ---> "+i[2].call]);for(var c=2;c<i.length;c++)console.log(i[c])}}function i(t,e,r){this.id=t,this.context=e||s.DEBUG}var o,s={},a={};i.prototype={log:function(t,e){t.value>=this.context.value&&n(e,{level:t,name:this.context.name,value:this.context.value})},debug:function(){this.log(s.DEBUG,arguments)},error:function(){this.log(s.ERROR,arguments)},info:function(){this.log(s.INFO,arguments)},warn:function(){this.log(s.WARN,arguments)},setLevel:function(t){t&&"value"in t&&(this.context=t)}},s.DEBUG={value:1,name:"DEBUG"},s.INFO={value:2,name:"INFO"},s.WARN={value:4,name:"WARN"},s.ERROR={value:8,name:"ERROR"},s.OFF={value:99,name:"OFF"},s.setLevel=function(t){o.setLevel(t)},s.debug=function(){o.debug.apply(o,arguments)},s.info=function(){o.info.apply(o,arguments)},s.warn=function(){o.warn.apply(o,arguments)},s.error=function(){o.error.apply(o,arguments)},s.get=function(t,e,r){return a[t]||function(){return a[t]=new i(t,e,r),a[t]}()},o=s.get("global"),e.exports=s},{}],8:[function(t,e,r){e.exports=function(e){try{return t(e)}catch(r){}}},{}],9:[function(t,e,r){function n(){this.emptyCallback=null,this.callbacks=[],this.yielded=!1,this.response=null,this.responseChain=[]}n.prototype={add:function(t,e,r){this.yielded||r?this.callbacks.push({fn:t,ctx:e}):t.apply(e||this,[this.response])},size:function(){return this.callbacks.length},isEmpty:function(){return 0===this.callbacks.length},empty:function(t,e){this.emptyCallback={fn:t,ctx:e}},"yield":function(t){this.yielded=t},take:function(t,e,r){var n;t&&(this.response=t,this.responseChain.push(t)),!this.yielded&&this.callbacks[0]&&(n=this.callbacks.shift(),n.fn.apply(n.ctx||this,[this.responseChain,e,r]),this.callbacks[0]&&this.emptyCallback&&this.emptyCallback.fn.call(this.emptyCallback.ctx||this))},flush:function(t,e,r){for(t&&(this.response=t,this.responseChain.push(t));this.callbacks[0]&&!this.yielded;){var n=this.callbacks.shift();n.fn.apply(n.ctx||this,[this.responseChain,e,r]),this.callbacks[0]&&this.emptyCallback&&this.emptyCallback.fn.call(this.emptyCallback.ctx||this)}}},e.exports=n},{}],10:[function(t,e,r){var n=t("./selfish").Base,i=t("./rtypes");e.exports=n.extend(i,{initialize:function(t,e,r){this.name=t,this.value=e,this.options=r||{}},numeric:function(){return this.value=parseFloat(this.value),this.assert({type:this.deployr.RNUMERIC,name:this.name,value:this.value,toString:this.toString})},integer:function(){return this.value=parseInt(this.value,10),this.assert({type:this.deployr.RINTEGER,name:this.name,value:this.value,toString:this.toString})},logical:function(){return this.assert({type:this.deployr.RBOOLEAN,name:this.name,value:this.value,toString:this.toString})},character:function(){return this.assert({type:this.deployr.RSTRING,name:this.name,value:this.value,toString:this.toString})},date:function(){return this.assert({type:this.deployr.RDATE,name:this.name,value:this.value,format:"yyyy-MM-dd",toString:this.toString})},posixct:function(){return this.assert({type:this.deployr.RPOSIX_DATE,name:this.name,value:this.value,format:"yyyy-MM-dd HH:mm:ss Z",toString:this.toString})},numericVector:function(){return this.assert({type:this.deployr.RNUMERIC_VECTOR,name:this.name,value:this.value,toString:this.toString})},integerVector:function(){return this.assert({type:this.deployr.RINTEGER_VECTOR,name:this.name,value:this.value,toString:this.toString})},logicalVector:function(){return this.assert({type:this.deployr.RBOOLEAN_VECTOR,name:this.name,value:this.value,toString:this.toString})},characterVector:function(){return this.assert({type:this.deployr.RSTRING_VECTOR,name:this.name,value:this.value,toString:this.toString})},dateVector:function(){return this.assert({type:this.deployr.RDATE_VECTOR,name:this.name,value:this.value,format:"yyyy-MM-dd",toString:this.toString})},posixctVector:function(){return this.assert({type:this.deployr.RPOSIX_DATE_VECTOR,name:this.name,value:this.value,format:"yyyy-MM-dd HH:mm:ss Z",toString:this.toString})},list:function(){return this.assert({type:this.deployr.RLIST,name:this.name,value:this.value,toString:this.toString})},dataframe:function(){return this.assert({type:this.deployr.RDATAFRAME,name:this.name,value:this.value,toString:this.toString})},factor:function(){var t=this.options;return this.assert({type:this.deployr.RFACTOR,name:this.name,value:this.value,ordered:!1,levels:t.levels,labels:t.labels,toString:this.toString})},ordered:function(){var t=this.options;return this.assert({type:this.deployr.RORDERED,name:this.name,value:this.value,ordered:!0,levels:t.levels,labels:t.labels,toString:this.toString})},numericMatrix:function(){return this.assert({type:this.deployr.RNUMERIC_MATRIX,name:this.name,value:this.value,toString:this.toString})},integerMatrix:function(){return this.assert({type:this.deployr.RINTEGER_MATRIX,name:this.name,value:this.value,toString:this.toString})},logicalMatrix:function(){return this.assert({type:this.deployr.RBOOLEAN_MATRIX,name:this.name,value:this.value,toString:this.toString})},characterMatrix:function(){return this.assert({type:this.deployr.RSTRING_MATRIX,name:this.name,value:this.value,toString:this.toString})},toString:function(){var t=this.options||{},e=t.levels?"[ levels = "+t.levels+"]":"",r=t.labels?"[ labels = "+t.labels+"]":"";return"[ name = "+this.name+" ] [ value = "+this.value+" ] [ type = "+this.type+" ] "+e+r}})},{"./rtypes":12,"./selfish":13}],11:[function(t,e,r){function n(t,e,r,n){var i;if(s.isObject(e)){if(i=e,!i.type!==t)throw new Error('IllegalArgumentError:Expecting "'+t+'" but found "'+i.type+'"')}else i=a["new"](e,r,n)[t]();return i}var i=t("./selfish").Base,o=t("./rtypes"),s=t("./lang"),a=t("./rinput");e.exports=i.extend(o,{numeric:function(t,e){return this.inputs.push(n(this.deployr.RNUMERIC,t,e)),this},integer:function(t,e){return this.inputs.push(n(this.deployr.RINTEGER,t,e)),this},logical:function(t,e){return this.inputs.push(n(this.deployr.RBOOLEAN,t,e)),this},character:function(t,e){return this.inputs.push(n(this.deployr.RSTRING,t,e)),this},date:function(t,e){return this.inputs.push(n(this.deployr.RDATE,t,e)),this},posixct:function(t,e){return this.inputs.push(n(this.deployr.RPOSIX_DATE,t,e)),this},numericVector:function(t,e){return this.inputs.push(n(this.deployr.RNUMERIC_VECTOR,t,e)),this},integerVector:function(t,e){return this.inputs.push(n(this.deployr.RINTEGER_VECTOR,t,e)),this},logicalVector:function(t,e){return this.inputs.push(n(this.deployr.RBOOLEAN_VECTOR,t,e)),this},characterVector:function(t,e){return this.inputs.push(n(this.deployr.RSTRING_VECTOR,t,e)),this},dateVector:function(t,e){return this.inputs.push(n(this.deployr.RDATE_VECTOR,t,e)),this},posixctVector:function(t,e){return this.inputs.push(n(this.deployr.RPOSIX_DATE_VECTOR,t,e)),this},list:function(t,e){return this.inputs.push(n(this.deployr.RLIST,t,e)),this},dataframe:function(t,e){return this.inputs.push(n(this.deployr.RDATAFRAME,t,e)),this},factor:function(t,e,r,i){var o={levels:r,labels:i};return this.inputs.push(n(this.deployr.RFACTOR,t,e,o)),this},ordered:function(t,e,r,i){var o={levels:r,labels:i};return this.inputs.push(n(this.deployr.RORDERED,t,e,o)),this},numericMatrix:function(t,e){return this.inputs.push(n(this.deployr.RNUMERIC_MATRIX,t,e)),this},integerMatrix:function(t,e){return this.inputs.push(n(this.deployr.RINTEGER_MATRIX,t,e)),this},logicalMatrix:function(t,e){return this.inputs.push(n(this.deployr.RBOOLEAN_MATRIX,t,e)),this},characterMatrix:function(t,e){return this.inputs.push(n(this.deployr.RSTRING_MATRIX,t,e)),this}})},{"./lang":6,"./rinput":10,"./rtypes":12,"./selfish":13}],12:[function(t,e,r){var n=t("./selfish").Base,i=t("./lang"),o={};e.exports=n.extend({
r:{PRIMITIVE:"primitive",DATAFRAME:"dataframe",LIST:"list",MATRIX:"matrix",DATE:"date",FACTOR:"factor",VECTOR:"vector"},deployr:{RBOOLEAN:"logical",RNUMERIC:"numeric",RINTEGER:"integer",RSTRING:"character",RDATE:"date",RPOSIX_DATE:"posixct",RBOOLEAN_VECTOR:"logicalVector",RNUMERIC_VECTOR:"numericVector",RINTEGER_VECTOR:"integerVector",RSTRING_VECTOR:"characterVector",RDATE_VECTOR:"dateVector",RPOSIX_DATE_VECTOR:"posixctVector",RLIST:"list",RDATAFRAME:"dataframe",RFACTOR:"factor",RORDERED:"ordered",RBOOLEAN_MATRIX:"logicalMatrix",RNUMERIC_MATRIX:"numericMatrix",RINTEGER_MATRIX:"integerMatrix",RSTRING_MATRIX:"characterMatrix"},isDate:function(t){return t===this.deployr.RDATE||t===this.deployr.RPOSIX_DATE||t===this.deployr.RDATE_VECTOR||t===this.deployr.RPOSIX_DATE_VECTOR||t===this.r.DATE},deployrToR:function(t){var e=this.deployr,r=this.r;return o[t]||(o[e.RBOOLEAN]=r.PRIMITIVE,o[e.RNUMERIC]=r.PRIMITIVE,o[e.RINTEGER]=r.PRIMITIVE,o[e.RSTRING]=r.PRIMITIVE,o[e.RDATE]=r.DATE,o[e.RPOSIX_DATE]=r.DATE,o[e.RBOOLEAN_VECTOR]=r.VECTOR,o[e.RNUMERIC_VECTOR]=r.VECTOR,o[e.RINTEGER_VECTOR]=r.VECTOR,o[e.RSTRING_VECTOR]=r.VECTOR,o[e.RDATE_VECTOR]=r.VECTOR,o[e.RPOSIX_DATE_VECTOR]=r.VECTOR,o[e.RLIST]=r.LIST,o[e.RDATAFRAME]=r.DATAFRAME,o[e.RFACTOR]=r.FACTOR,o[e.RORDERED]=r.FACTOR,o[e.RBOOLEAN_MATRIX]=r.MATRIX,o[e.RNUMERIC_MATRIX]=r.MATRIX,o[e.RINTEGER_MATRIX]=r.MATRIX,o[e.RSTRING_MATRIX]=r.MATRIX),o[t]},assert:function(t){var e,r=this.deployr,n=null,o=t.value;o=i.isArray(o)?o:[o];for(var s=0;s<o.length;s++){var a=o[s];switch(t.type){case r.RNUMERIC:case r.RNUMERIC_VECTOR:case r.RINTEGER:case r.RINTEGER_VECTOR:e=i.isNumber;break;case r.RBOOLEAN:case r.RBOOLEAN_VECTOR:e=i.isBoolean;break;case r.RSTRING:case r.RSTRING_VECTOR:e=i.isString;break;case r.RDATE:case r.RPOSIX_DATE:case r.RDATE_VECTOR:case r.RPOSIX_DATE_VECTOR:e=i.isDate;break;case r.RFACTOR:case r.RORDERED:case r.RDATAFRAME:case r.RINTEGER_MATRIX:case r.RBOOLEAN_MATRIX:case r.RSTRING_MATRIX:e=n}if(e&&!e(a))throw new Error('RInputFormatError: "'+a+'" is not a valid "'+t.type+'" type for input "'+t.name+'"')}return t}})},{"./lang":6,"./selfish":13}],13:[function(e,r,n){!("function"!=typeof t?function(t){t(null,"undefined"!=typeof n?n:window)}:t)(function(t,e){"use strict";e.Base=Object.freeze(Object.create(Object.prototype,{"new":{value:function(){var t=Object.create(this);return t.initialize.apply(t,arguments),t}},initialize:{value:function(){}},merge:{value:function(){var t={};return Array.prototype.forEach.call(arguments,function(e){Object.getOwnPropertyNames(e).forEach(function(r){t[r]=Object.getOwnPropertyDescriptor(e,r)})}),Object.defineProperties(this,t),this}},extend:{value:function(){return Object.freeze(this.merge.apply(Object.create(this),arguments))}}}))})},{}],14:[function(t,e,r){var n=t("./lang"),i=r.get=function(t,e){function r(t,e,n){for(var i in t){var o=e.apply(this,[i,t[i],n]);if(o)return o;t[i]instanceof Object&&!(t[i]instanceof Array)&&r(t[i],e,i)}}function i(t,e){var n={};return r(t,function(t,r,i){return t===e?n=r:null}),n}function o(t){for(var e in t)if(t.hasOwnProperty(e))return t;return n.isObject(t)?null:t}return o(i(t,e))},o=r.inArray=function(t,e,r){var n,i=t.length;for(n=0;n<i;n++)if(r){if(t[n][r]===e)return t[n]}else if(t[n]===e)return t[n];return null};r.merge=function(t,e){t&&"object"==typeof t||(t={}),e&&"object"==typeof e||(e={});for(var r in e)t[r]=e[r];return t},r.workspace=function(t,e){var r=i(t,"workspace");return r?e?o(r.objects,e,"name"):r.objects||r.object:null},r.signature=function(){var t,e=Array.prototype.slice.call(arguments[0],0),r=e.length,i=!1,o={};if(1===r&&n.isObject(e[0]))o=e[0],t=o.project?"/r/project/execute/script":"/r/repository/script/execute";else if(1===r&&n.isString(e[0]))e=e[0].split("/"),t="/r/repository/script/execute",o={author:e[1],directory:e[2],filename:e[3]};else if(2===r){var s=e[1];t=s?"/r/project/execute/script":"/r/repository/script/execute",e=e[0].split("/"),o={project:s,author:e[1],directory:e[2],filename:e[3]}}else r>2&&(o={author:e[2],directory:e[1],filename:e[0]});return o.project&&n.isBoolean(o.project)&&(delete o.project,i=!0),{api:t,opts:o,create:i}}},{"./lang":6}],15:[function(t,e,r){},{}],16:[function(t,e,r){function n(){p&&h&&(p=!1,h.length?l=h.concat(l):f=-1,l.length&&i())}function i(){if(!p){var t=a(n);p=!0;for(var e=l.length;e;){for(h=l,l=[];++f<e;)h&&h[f].run();f=-1,e=l.length}h=null,p=!1,u(t)}}function o(t,e){this.fun=t,this.array=e}function s(){}var a,u,c=e.exports={};!function(){try{a=setTimeout}catch(t){a=function(){throw new Error("setTimeout is not defined")}}try{u=clearTimeout}catch(t){u=function(){throw new Error("clearTimeout is not defined")}}}();var h,l=[],p=!1,f=-1;c.nextTick=function(t){var e=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)e[r-1]=arguments[r];l.push(new o(t,e)),1!==l.length||p||a(i,0)},o.prototype.run=function(){this.fun.apply(null,this.array)},c.title="browser",c.browser=!0,c.env={},c.argv=[],c.version="",c.versions={},c.on=s,c.addListener=s,c.once=s,c.off=s,c.removeListener=s,c.removeAllListeners=s,c.emit=s,c.binding=function(t){throw new Error("process.binding is not supported")},c.cwd=function(){return"/"},c.chdir=function(t){throw new Error("process.chdir is not supported")},c.umask=function(){return 0}},{}],17:[function(e,r,n){(function(e){!function(n){"use strict";function i(t){d(function(){throw t})}function o(t){return this.then(t,n)}function s(t){return this.then(n,t)}function a(t,e){return this.then(function(e){return y(t)?t.apply(null,m(e)?e:[e]):b.onlyFuncs?e:t},e||n)}function u(t){function e(){t()}return this.then(e,e),this}function c(t){return this.then(function(e){return y(t)?t.apply(null,m(e)?e.splice(0,0,void 0)&&e:[void 0,e]):b.onlyFuncs?e:t},function(e){return t(e)})}function h(t){return this.then(n,t?function(e){throw t(e),e}:i)}function l(t,e){var r=T(t);if(1===r.length&&m(r[0])){if(!r[0].length)return b.fulfilled([]);r=r[0]}var n=[],i=b(),o=r.length;if(o)for(var s=function(t){r[t]=b.promisify(r[t]),r[t].then(function(s){n[t]=e?r[t]:s,--o||i.resolve(n)},function(s){e?(n[t]=r[t],--o||i.resolve(n)):i.reject(s)})},a=0,u=o;a<u;a++)s(a);else i.resolve(n);return i.promise}function p(t,e){return t.then(y(e)?e:function(){return e})}function f(t){var e=T(t);1===e.length&&m(e[0])&&(e=e[0]);for(var r=b(),n=0,i=e.length,o=b.resolved();n<i;n++)o=p(o,e[n]);return r.resolve(o),r.promise}var d,y=function(t){return"function"==typeof t},m=function(t){return Array.isArray?Array.isArray(t):t instanceof Array},R=function(t){return!(!t||!(typeof t).match(/function|object/))},v=function(t){return t===!1||t===n||null===t},T=function(t,e){return[].slice.call(t,e)},E="undefined",O=typeof TypeError===E?Error:TypeError;if(typeof e!==E&&e.nextTick)d=e.nextTick;else if(typeof MessageChannel!==E){var g=new MessageChannel,j=[];g.port1.onmessage=function(){j.length&&j.shift()()},d=function(t){j.push(t),g.port2.postMessage(0)}}else d=function(t){setTimeout(t,0)};var b=function(t){function e(){if(0!==f){var t,e=m,r=0,n=e.length,i=~f?0:1;for(m=[];r<n;r++)(t=e[r][i])&&t(l)}}function r(t){function n(t){return function(e){return o?void 0:(o=!0,t(e))}}var o=!1;if(f)return this;try{var s=R(t)&&t.then;if(y(s)){if(t===T)throw new O("Promise can't resolve itself");return s.call(t,n(r),n(i)),this}}catch(a){return n(i)(a),this}return p(function(){l=t,f=1,e()}),this}function i(t){return f||p(function(){try{throw t}catch(r){l=r}f=-1,e()}),this}var l,p=(n!==t?t:b.alwaysAsync)?d:function(t){t()},f=0,m=[],T={then:function(t,r){var n=b();return m.push([function(e){try{v(t)?n.resolve(e):n.resolve(y(t)?t(e):b.onlyFuncs?e:t)}catch(r){n.reject(r)}},function(t){if((v(r)||!y(r)&&b.onlyFuncs)&&n.reject(t),r)try{n.resolve(y(r)?r(t):r)}catch(e){n.reject(e)}}]),0!==f&&p(e),n.promise},success:o,error:s,otherwise:s,apply:a,spread:a,ensure:u,nodify:c,rethrow:h,isPending:function(){return 0===f},getStatus:function(){return f}};return T.toSource=T.toString=T.valueOf=function(){return l===n?this:l},{promise:T,resolve:r,fulfill:r,reject:i}};if(b.deferred=b.defer=b,b.nextTick=d,b.alwaysAsync=!0,b.onlyFuncs=!0,b.resolved=b.fulfilled=function(t){return b(!0).resolve(t).promise},b.rejected=function(t){return b(!0).reject(t).promise},b.wait=function(t){var e=b();return setTimeout(e.resolve,t||0),e.promise},b.delay=function(t,e){var r=b();return setTimeout(function(){try{r.resolve(y(t)?t.apply(null):t)}catch(e){r.reject(e)}},e||0),r.promise},b.promisify=function(t){return t&&y(t.then)?t:b.resolved(t)},b.all=function(){return l(arguments,!1)},b.resolveAll=function(){return l(arguments,!0)},b.sequence=function(){return f(arguments)},b.nodeCapsule=function(t,e){return e||(e=t,t=void 0),function(){var r=b(),n=T(arguments);n.push(function(t,e){t?r.reject(t):r.resolve(arguments.length>2?T(arguments,1):e)});try{e.apply(t,n)}catch(i){r.reject(i)}return r.promise}},"function"==typeof t&&t.amd)t("D.js",[],function(){return b});else if(typeof r!==E&&r.exports)r.exports=b;else if(typeof window!==E){var S=window.D;b.noConflict=function(){return window.D=S,b},window.D=b}}()}).call(this,e("_process"))},{_process:16}],18:[function(t,e,r){function n(){}function i(t){var e={}.toString.call(t);switch(e){case"[object File]":case"[object Blob]":case"[object FormData]":return!0;default:return!1}}function o(){if(R.XMLHttpRequest&&("file:"!=R.location.protocol||!R.ActiveXObject))return new XMLHttpRequest;try{return new ActiveXObject("Microsoft.XMLHTTP")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.6.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP.3.0")}catch(t){}try{return new ActiveXObject("Msxml2.XMLHTTP")}catch(t){}return!1}function s(t){return t===Object(t)}function a(t){if(!s(t))return t;var e=[];for(var r in t)null!=t[r]&&e.push(encodeURIComponent(r)+"="+encodeURIComponent(t[r]));return e.join("&")}function u(t){for(var e,r,n={},i=t.split("&"),o=0,s=i.length;o<s;++o)r=i[o],e=r.split("="),n[decodeURIComponent(e[0])]=decodeURIComponent(e[1]);return n}function c(t){var e,r,n,i,o=t.split(/\r?\n/),s={};o.pop();for(var a=0,u=o.length;a<u;++a)r=o[a],e=r.indexOf(":"),n=r.slice(0,e).toLowerCase(),i=v(r.slice(e+1)),s[n]=i;return s}function h(t){return t.split(/ *; */).shift()}function l(t){return m(t.split(/ *; */),function(t,e){var r=e.split(/ *= */),n=r.shift(),i=r.shift();return n&&i&&(t[n]=i),t},{})}function p(t,e){e=e||{},this.req=t,this.xhr=this.req.xhr,this.text="HEAD"!=this.req.method?this.xhr.responseText:null,this.setStatusProperties(this.xhr.status),this.header=this.headers=c(this.xhr.getAllResponseHeaders()),this.header["content-type"]=this.xhr.getResponseHeader("content-type"),this.setHeaderProperties(this.header),this.body="HEAD"!=this.req.method?this.parseBody(this.text):null}function f(t,e){var r=this;y.call(this),this._query=this._query||[],this.method=t,this.url=e,this.header={},this._header={},this.on("end",function(){var t=null,e=null;try{e=new p(r)}catch(n){t=new Error("Parser is unable to parse the response"),t.parse=!0,t.original=n}r.callback(t,e)})}function d(t,e){return"function"==typeof e?new f("GET",t).end(e):1==arguments.length?new f("GET",t):new f(t,e)}var y=t("emitter"),m=t("reduce"),R="undefined"==typeof window?this:window,v="".trim?function(t){return t.trim()}:function(t){return t.replace(/(^\s*|\s*$)/g,"")};d.serializeObject=a,d.parseString=u,d.types={html:"text/html",json:"application/json",xml:"application/xml",urlencoded:"application/x-www-form-urlencoded",form:"application/x-www-form-urlencoded","form-data":"application/x-www-form-urlencoded"},d.serialize={"application/x-www-form-urlencoded":a,"application/json":JSON.stringify},d.parse={"application/x-www-form-urlencoded":u,"application/json":JSON.parse},p.prototype.get=function(t){return this.header[t.toLowerCase()]},p.prototype.setHeaderProperties=function(t){var e=this.header["content-type"]||"";this.type=h(e);var r=l(e);for(var n in r)this[n]=r[n]},p.prototype.parseBody=function(t){var e=d.parse[this.type];return e&&t&&t.length?e(t):null},p.prototype.setStatusProperties=function(t){var e=t/100|0;this.status=t,this.statusType=e,this.info=1==e,this.ok=2==e,this.clientError=4==e,this.serverError=5==e,this.error=(4==e||5==e)&&this.toError(),this.accepted=202==t,this.noContent=204==t||1223==t,this.badRequest=400==t,this.unauthorized=401==t,this.notAcceptable=406==t,this.notFound=404==t,this.forbidden=403==t},p.prototype.toError=function(){var t=this.req,e=t.method,r=t.url,n="cannot "+e+" "+r+" ("+this.status+")",i=new Error(n);return i.status=this.status,i.method=e,i.url=r,i},d.Response=p,y(f.prototype),f.prototype.use=function(t){return t(this),this},f.prototype.timeout=function(t){return this._timeout=t,this},f.prototype.clearTimeout=function(){return this._timeout=0,clearTimeout(this._timer),this},f.prototype.abort=function(){if(!this.aborted)return this.aborted=!0,this.xhr.abort(),this.clearTimeout(),this.emit("abort"),this},f.prototype.set=function(t,e){if(s(t)){for(var r in t)this.set(r,t[r]);return this}return this._header[t.toLowerCase()]=e,this.header[t]=e,this},f.prototype.unset=function(t){return delete this._header[t.toLowerCase()],delete this.header[t],this},f.prototype.getHeader=function(t){return this._header[t.toLowerCase()]},f.prototype.type=function(t){return this.set("Content-Type",d.types[t]||t),this},f.prototype.accept=function(t){return this.set("Accept",d.types[t]||t),this},f.prototype.auth=function(t,e){var r=btoa(t+":"+e);return this.set("Authorization","Basic "+r),this},f.prototype.query=function(t){return"string"!=typeof t&&(t=a(t)),t&&this._query.push(t),this},f.prototype.field=function(t,e){return this._formData||(this._formData=new FormData),this._formData.append(t,e),this},f.prototype.attach=function(t,e,r){return this._formData||(this._formData=new FormData),this._formData.append(t,e,r),this},f.prototype.send=function(t){var e=s(t),r=this.getHeader("Content-Type");if(e&&s(this._data))for(var n in t)this._data[n]=t[n];else"string"==typeof t?(r||this.type("form"),r=this.getHeader("Content-Type"),"application/x-www-form-urlencoded"==r?this._data=this._data?this._data+"&"+t:t:this._data=(this._data||"")+t):this._data=t;return e?(r||this.type("json"),this):this},f.prototype.callback=function(t,e){var r=this._callback;return this.clearTimeout(),2==r.length?r(t,e):t?this.emit("error",t):void r(e)},f.prototype.crossDomainError=function(){var t=new Error("Origin is not allowed by Access-Control-Allow-Origin");t.crossDomain=!0,this.callback(t)},f.prototype.timeoutError=function(){var t=this._timeout,e=new Error("timeout of "+t+"ms exceeded");e.timeout=t,this.callback(e)},f.prototype.withCredentials=function(){return this._withCredentials=!0,this},f.prototype.end=function(t){var e=this,r=this.xhr=o(),s=this._query.join("&"),a=this._timeout,u=this._formData||this._data;if(this._callback=t||n,r.onreadystatechange=function(){if(4==r.readyState)return 0==r.status?e.aborted?e.timeoutError():e.crossDomainError():void e.emit("end")},r.upload&&(r.upload.onprogress=function(t){t.percent=t.loaded/t.total*100,e.emit("progress",t)}),a&&!this._timer&&(this._timer=setTimeout(function(){e.abort()},a)),s&&(s=d.serializeObject(s),this.url+=~this.url.indexOf("?")?"&"+s:"?"+s),r.open(this.method,this.url,!0),this._withCredentials&&(r.withCredentials=!0),"GET"!=this.method&&"HEAD"!=this.method&&"string"!=typeof u&&!i(u)){var c=d.serialize[this.getHeader("Content-Type")];c&&(u=c(u))}for(var h in this.header)null!=this.header[h]&&r.setRequestHeader(h,this.header[h]);return this.emit("request",this),r.send(u),this},d.Request=f,d.get=function(t,e,r){var n=d("GET",t);return"function"==typeof e&&(r=e,e=null),e&&n.query(e),r&&n.end(r),n},d.head=function(t,e,r){var n=d("HEAD",t);return"function"==typeof e&&(r=e,e=null),e&&n.send(e),r&&n.end(r),n},d.del=function(t,e){var r=d("DELETE",t);return e&&r.end(e),r},d.patch=function(t,e,r){var n=d("PATCH",t);return"function"==typeof e&&(r=e,e=null),e&&n.send(e),r&&n.end(r),n},d.post=function(t,e,r){var n=d("POST",t);return"function"==typeof e&&(r=e,e=null),e&&n.send(e),r&&n.end(r),n},d.put=function(t,e,r){var n=d("PUT",t);return"function"==typeof e&&(r=e,e=null),e&&n.send(e),r&&n.end(r),n},e.exports=d},{emitter:19,reduce:20}],19:[function(t,e,r){function n(t){if(t)return i(t)}function i(t){for(var e in n.prototype)t[e]=n.prototype[e];return t}e.exports=n,n.prototype.on=n.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks[t]=this._callbacks[t]||[]).push(e),this},n.prototype.once=function(t,e){function r(){n.off(t,r),e.apply(this,arguments)}var n=this;return this._callbacks=this._callbacks||{},r.fn=e,this.on(t,r),this},n.prototype.off=n.prototype.removeListener=n.prototype.removeAllListeners=n.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var r=this._callbacks[t];if(!r)return this;if(1==arguments.length)return delete this._callbacks[t],this;for(var n,i=0;i<r.length;i++)if(n=r[i],n===e||n.fn===e){r.splice(i,1);break}return this},n.prototype.emit=function(t){this._callbacks=this._callbacks||{};var e=[].slice.call(arguments,1),r=this._callbacks[t];if(r){r=r.slice(0);for(var n=0,i=r.length;n<i;++n)r[n].apply(this,e)}return this},n.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks[t]||[]},n.prototype.hasListeners=function(t){return!!this.listeners(t).length}},{}],20:[function(t,e,r){e.exports=function(t,e,r){for(var n=0,i=t.length,o=3==arguments.length?r:t[n++];n<i;)o=e.call(null,o,t[n],++n,t);return o}},{}]},{},[2])(2)});